/***************************************************************************
                          abstracttooldialog.h  -  description
                             -------------------
    begin                : Wed Feb 19 11:00:00 CEST 2020
    copyright            : (C) 2020 by Nicola Doebelin
    email                : ndoebelin@gmx.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ABSTRACTTOOLDIALOG_H
#define ABSTRACTTOOLDIALOG_H

#include "projectWidget/projectwidget.h"
#include <QObject>
#include <QWidget>

class AbstractToolDialog : public QDialog
{
    Q_OBJECT
public:
    explicit AbstractToolDialog(QWidget *parent = 0);

    virtual void setProject(ProjectWidget *);
    virtual void clearProject();

protected:
    SettingsManager *settings;
    const ProjectWidget *graphProject;
    GraphWindow *graphView;
    GraphDataController *graphControl;
    Scan *temporaryScan;

    virtual void preSetProject(ProjectWidget *) = 0;
    virtual void postSetProject(ProjectWidget *) = 0;
    virtual void initSettings() {}
    virtual void saveSettings() {}
    virtual bool checkBackend();
    virtual void keepTemporary() = 0;
    virtual void clearTemporary() = 0;
    virtual void clearGui() = 0;

    int tempScanIndex();

protected slots:
    virtual void updateView() = 0;
    void closeAndAccept();
    void closeAndReject();
};

#endif // ABSTRACTTOOLDIALOG_H
